#include "bsp.h"

unsigned volatile int tics = 0;
unsigned volatile long tics_long = 0;

void __attribute__((interrupt))
timer_ra_handler ()
{
  tics ++;
  tics_long ++;
  traic = 5;
}

static volatile unsigned zx = 0;
volatile unsigned long uptime_seconds = 0;
volatile unsigned long zero_crossings = 0;

void __attribute__((interrupt))
int0_handler ()
{
  zero_crossings ++;
  zx ++;
  if (zx == 60)
    {
      zx = 0;
      uptime_seconds ++;
    }
}

static void __attribute__((constructor))
timer_A_initialize ()
{
  tracr.b = 0;
  traioc.b = 0;
  tramr.b = 0;
#ifdef CLOCK_125KHz
  trapre = 0;
  tra = 124;
#else
  trapre = (CLOCK_HZ / 100000) - 1;
  tra = 100-1;
#endif
  traic = 5;
  tracr.tstart = 1;

  inten.b = 0x01;
  int0ic = 5;
}

int
wait_ms (int ms)
{
  int now = tics;
  while ((int)(tics - now) < ms)
    ;
}
